"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const operators_1 = require("rxjs/operators");
const core_1 = require("@marblejs/core");
const middleware_body_1 = require("@marblejs/middleware-body");
exports.createMarbleServer = () => {
    const echoEffect$ = core_1.r.pipe(core_1.r.matchPath('/'), core_1.r.matchType('POST'), core_1.r.useEffect(req$ => req$.pipe(operators_1.map((req) => ({
        headers: {
            'Content-Type': 'text/plain',
        },
        body: req.body,
    })))));
    const errorEffect$ = core_1.r.pipe(core_1.r.matchPath('/'), core_1.r.matchType('GET'), core_1.r.useEffect(req$ => req$.pipe(operators_1.map(() => ({
        headers: {
            'Content-Length': '1',
            'Transfer-Encoding': 'chunked',
        },
        body: 'x',
    })))));
    return core_1.httpListener({
        middlewares: [
            middleware_body_1.bodyParser$(),
        ],
        effects: [
            echoEffect$,
            errorEffect$,
        ],
    }).run(core_1.createContext());
};
